package mesquite.ac3.lib;

//This method calculates symmetric (p=0.5) binomial terms.  Note that
//this symmetry simplifies two-tailed calculations and the pq power
//expressions, which are constant over the loop.  There are probably more
//expression optimizations in the C(n,r) code, but this is a little better 
//than calculating all three factorials outright

public class SignTest {

	/** This does a signTest calculation */
	public static double signTest(int N1, int N2) {
		if (N1 > N2)     //calculate the smaller tail value
			return binomial050(N1+N2,N2);
		else
			return binomial050(N1+N2,N1);
	}
	
	public static double binomial050(int N, int R) {
		double result = 0;
		double pwr = Math.exp(N*Math.log(0.5));
		for (int count = 0;count <= R; count++) {
			double pnc = perm(N,count);
			double f = perm(N-count,1);
			double comb = pnc/f;
			double bino = pwr*comb;
			result += bino;
		}
		return result;
	}
			
		
	 /** This helper function calculates P(n,r) as a truncated factorial */
	private static double perm(int N, int R) {
		double result = 1.0;
		for (int i = N; i >= R+1; i--)
			result *= i;
		return result;
	}	


	
}
