/* AC3 Mesquite module */

package mesquite.ac3.lib;

import mesquite.lib.*;
import mesquite.lib.characters.CharacterDistribution;
import mesquite.lib.duties.*;


/* ======================================================================== */
/**Supplies numbers for each node of a tree.*/

public abstract class ContrastForChar extends NumbersForNodesAndChar {
        // These are the contrast options defined for setOption
	public static final int CONTRAST = 0;
	public static final int ABSCONTRAST = 1;
	public static final int RAWCONTRAST = 2;
	public static final int SD =  3;
	public static final int VPRIME = 4;
	public static final int NODEVALUE = 5;
	public static final int CORRECTEDHEIGHT = 6;
	public static final int TIPS = 7;
	public static final int RESIDUAL = 8;
	public static final int ABSRESIDUAL = 9;
	public static final int RAWHEIGHT = 10;
	//modif
	public static final int ACDCP=11;
	//

   	 public Class getDutyClass() {
   	 	return ContrastForChar.class;
   	 }
 	public String getDutyName() {
 		return "Contrasts on Tree using a Character Distribution";
   	 }
	public abstract double[] calculateStandardDeviations(Tree tree);

	public abstract void calculateNumbers(Tree tree, CharacterDistribution charDistribution, NumberArray result, MesquiteString resultString);

	
	public abstract void setOption(int option);
	public abstract void setOptionWithChangeParameters(int option);
	public abstract void setXCharForReport(int xChar);
	public abstract void setYCharForReport(int yChar);
	public abstract void takeControl(boolean take);
	
}
