/* AC3 Mesquite module */
package mesquite.ac3.lib;

import mesquite.lib.CommandRecord;
import mesquite.lib.MesquiteString;
import mesquite.lib.NumberArray;
import mesquite.lib.Tree;
import mesquite.lib.characters.CharacterDistribution;
import mesquite.lib.duties.*;


/* ======================================================================== */

public abstract class ResidualsCalculator extends NumbersForNodesWith2Char {

   	 public Class getDutyClass() {
   	 	return ResidualsCalculator.class;
   	 }
 	public String getDutyName() {
 		return "Calculates residuals in contrasts regression";
   	 }
 	
	public abstract void setOption(int option);

	public abstract void calculateNumbers(Tree tree, CharacterDistribution charDistribution1, CharacterDistribution charDistribution2, NumberArray result, MesquiteString resultString);
	

}
